<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

    //require_once( dirname(__FILE__) . "/app.php.inc" );
    require_once( dirname(__FILE__) . "/manager.util.php.inc" );
    
    require_once( dirname(__FILE__) . "/manager.base.php.inc" );

    /* --------------------------------------------------------------------
     * Ϲܥ饹date, datetime, time, year, month, entrydate
     * 
     */ 
    class DateEntryItem extends BaseEntryItem
    {
    	
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $xmlSchemaData : б륹DataXMLǡ
		 */
    	function DateEntryItem( $xmlSchemaData, $entryName, $entryId  )
    	{
    		// ١󥹥ȥ饯θƤӽФ
    		parent::BaseEntryItem( $xmlSchemaData, $entryName, $entryId  );
    	}
    	
		/* ----------------------------------------------------------------
		 * ܤXMLΡɤ򿷵롣
		 * $xmlDocParentEntry : ȥDOM֥ȡ
		 * return : XMLΡɡ
		 */
    	function createNew( $xmlDocParentEntry )
    	{
   			$newNode = parent::createNew( $xmlDocParentEntry );
			
			$this->setYMDHNS( $newNode, date( "Y" ), date( "m" ), date( "d" ), date( "H" ), date( "i" ), date( "s" ) );
    		
    		return $newNode;
    	}
		
		function createEntryDate( &$xmlEntry )
		{
			$this->setYMDHNS( $xmlEntry, date( "Y" ), date( "m" ), date( "d" ), date( "H" ), date( "i" ), date( "s" ) );
		}
		
		function setYMDHNS( &$xmlNewNode, $year, $month, $day, $hour, $minute, $second )
		{
			// ǯʬ
			$sYear = sprintf( "%04d", $year );
			$sMonth = sprintf( "%02d", $month );
			$sDay = sprintf( "%02d", $day );
			$sHour = sprintf( "%02d", $hour );
			$sMinute = sprintf( "%02d", $minute );
			$sSecond = sprintf( "%02d", $second );
			
			// timeͤμ
			$time = mktime( intval($sHour), intval($sMinute), intval($sSecond), intval($sMonth), intval($sDay), intval($sYear) );
			
			// ׻롣
			$arrWeekday = array( 'sun', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat' );
			$iWeekday = date('w', $time );
			$sWeekday = $arrWeekday[ $iWeekday ];
			
			if ( $this->dataType == 'entrydate' )
			{
				$strDate = $sYear . '-' . $sMonth . '-' . $sDay . ' ' . $sHour . ':' . $sMinute;
				$xmlNewNode->set_attribute( 'date', $strDate );
			}
			else
			{
				EntryUtil::deleteTextNode( $xmlNewNode );
				
				switch( $this->dataType )
				{
					case 'datetime' :
						$strDate = $sYear . '-' . $sMonth . '-' . $sDay . ' ' . $sHour . ':' . $sMinute;
						break;
					
					case 'date' :
						$strDate = $sYear . '-' . $sMonth . '-' . $sDay;
						break;
					
					case 'time' :
						$strDate = $sHour . ':' . $sMinute;
						break;
					
					case 'year' :
						$strDate = $sYear;
						break;
					
					case 'month' :
						$strDate = $sYear . '-' . $sMonth;
						break;
					
				}
				
				$xmlNewNode->set_content( $strDate );
			}
			
			$xmlNewNode->set_attribute( 'year', $sYear );
			$xmlNewNode->set_attribute( 'month', $sMonth );
			$xmlNewNode->set_attribute( 'day', $sDay );
			$xmlNewNode->set_attribute( 'hour', $sHour );
			$xmlNewNode->set_attribute( 'minute', $sMinute );
			$xmlNewNode->set_attribute( 'second', $sSecond );	
			$xmlNewNode->set_attribute( 'weekday', $sWeekday );
			$xmlNewNode->set_attribute( 'time', $time );
		}
		
		
		/* ----------------------------------------------------------------
		 * Ƥǥȥܤ򹹿롣
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
    	function update( $xpathEntry, $currentEntry )
    	{
			
    		// ȥXML
    		/// ȥ깹(entrydate)ξ硢entryǼȤƹ롣
    		if ( $this->dataType == 'entrydate' )
			{
	            $xmlEntryDataArr = $xpathEntry->xpath_eval( $currentEntry );
				
				// ȥ깹(entrydate)ξ礵ˡָץե饰ΩäƤ麣ꤷƽλ롣
				if ( isset( $_POST[ 'cmsd_date_autoupdate' ] ) )
				{
					$this->setYMDHNS( $xmlEntryDataArr->nodeset[0], date( "Y" ), date( "m" ), date( "d" ), date( "H" ), date( "i" ), date( "s" ) );
					return true;
				}
			}
			else
			{
	            $xmlEntryDataArr = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
			}
   	        $xmlEntryData = $xmlEntryDataArr->nodeset[0];
			
			
			// 
			$year = '';
			$month = '';
			$day = '';
			$hour = '';
			$minute = '';
			$second = '';
						
			// year
			if ( in_array( $this->dataType, array( 'entrydate', 'datetime', 'date', 'year', 'month' ) ) )
			{
				$year = $_POST[ $this->dataName . '_year' ];
				
				// ϰϥå
				$iYear = intval( $year ); 
				if ( $iYear < 0 or $iYear > 9999 )
				{
					$this->errorMessage = sprintf( "%s(ǯ)  0-9999ϰϤĶޤ", $this->dataCaption );
					return false;
				}
				
			}
			
			// month
			if ( in_array( $this->dataType, array( 'entrydate', 'datetime', 'date', 'month' ) ) )
			{
				$month = $_POST[ $this->dataName . '_month' ];
				
				// ϰϥå
				$iMonth = intval( $month ); 
				if ( $iMonth < 0 or $iMonth > 12 )
				{
					$this->errorMessage = sprintf( "%s()  0-12ϰϤĶޤ", $this->dataCaption );
					return false;
				}
				
			}

			// day
			if ( in_array( $this->dataType, array( 'entrydate', 'datetime', 'date' ) ) )
			{
				$day = $_POST[ $this->dataName . '_day' ];
				
				// ϰϥå
				$iDay = intval( $day ); 
				if ( $iDay < 0 or $iDay > 31 )
				{
					$this->errorMessage = sprintf( "%s()  0-31ϰϤĶޤ", $this->dataCaption );
					return false;
				}
			}
			
			// hour
			if ( in_array( $this->dataType, array( 'entrydate', 'datetime', 'time' ) ) )
			{
				$hour = $_POST[ $this->dataName . '_hour' ];
				
				// ϰϥå
				$iHour = intval( $hour ); 
				if ( $iHour < 0 or $iHour > 23 )
				{
					$this->errorMessage = sprintf( "%s()  0-24ϰϤĶޤ", $this->dataCaption );
					return false;
				}
			}

			// minute
			if ( in_array( $this->dataType, array( 'entrydate', 'datetime', 'time' ) ) )
			{
				$minute = $_POST[ $this->dataName . '_minute' ];
				
				// ϰϥå
				$iMinute = intval( $minute ); 
				if ( $iMinute < 0 or $iMinute > 59 )
				{
					$this->errorMessage = sprintf( "%s()  0-59ϰϤĶޤ", $this->dataCaption );
					return false;
				}
			}
									
			$this->setYMDHNS( $xmlEntryData, $year, $month, $day, $hour, $minute, $second );
    	    
    	    return true;
    	
    	}
 
		
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItemXML( $xpathEntry, $currentEntry, &$xmlOutputEntryData )
    	{
			if ( $this->dataType == 'entrydate' )
			{
				// ߤγؤentryǤˡ
				$xmlEntryDataArr = $xpathEntry->xpath_eval( $currentEntry );
			}
			else
			{
				// ߤγؤоݥǡܤ
	            $xmlEntryDataArr = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
			}
			
   			$xmlEntryData = $xmlEntryDataArr->nodeset[0];

			
			$year = $xmlEntryData->get_attribute('year');
			$month = $xmlEntryData->get_attribute('month');
			$day = $xmlEntryData->get_attribute('day');
			$hour = $xmlEntryData->get_attribute('hour');
			$minute = $xmlEntryData->get_attribute('minute');
			$second = $xmlEntryData->get_attribute('second');
			
			$xmlOutputEntryData->set_attribute('year', $year );
			$xmlOutputEntryData->set_attribute('month', $month );
			$xmlOutputEntryData->set_attribute('day', $day );
			$xmlOutputEntryData->set_attribute('hour', $hour );
			$xmlOutputEntryData->set_attribute('minute', $minute );
			$xmlOutputEntryData->set_attribute('second', $second );
    		
    	}
		
    
    }

?>