<?php
	/*=======================================================================
	 * copyright (c) AL-Design Works 
	 * http://cms.al-design.jp/
	 * Υե CMS Designer ΰǤ
	 * ܤ饤󥹵ˤĤƤϥ֥Ȥ򻲾ȤƤ
	 *=======================================================================
	 */

    require_once( dirname(__FILE__) . "/app.php.inc" );
    require_once( dirname(__FILE__) . "/manager.util.php.inc" );
    
    require_once( dirname(__FILE__) . "/manager.base.php.inc" );

    /* --------------------------------------------------------------------
     * Ϲܥ饹
     * 
     */ 
    class MenuEntryItem extends BaseEntryItem
    {
    	var $menuitems = NULL;
		var $defaultId = NULL;
    	
		/* ----------------------------------------------------------------
		 * 󥹥ȥ饯
		 * $xmlSchemaData : б륹DataXMLǡ
		 */
    	function MenuEntryItem( $xmlSchemaData, $entryName, $entryId  )
    	{
    		// ١󥹥ȥ饯θƤӽФ
    		parent::BaseEntryItem( $xmlSchemaData, $entryName, $entryId  );
    		
			// ˥塼ǤȤƼ
			$this->menuitems = array();
            foreach( $xmlSchemaData->child_nodes() as $node )
            {
                if ( $node->node_type() == XML_ELEMENT_NODE and $node->tagname() == 'menuitem' )
                {
					if ( empty( $this->defaultId ) )
					{
						$this->defaultId = file2code( $node->get_attribute('id') );
					}
					$this->menuitems[ file2code( $node->get_attribute('id') ) ] = file2code( $node->get_content() );
                }
            }
    	}
    	
		/* ----------------------------------------------------------------
		 * ܤXMLΡɤ򿷵롣
		 * $xmlDocParentEntry : ȥDOM֥ȡ
		 * return : XMLΡɡ
		 */
    	function createNew( $xmlDocParentEntry )
    	{
   			$newNode = parent::createNew( $xmlDocParentEntry );
    		$newNode->set_content( fileconv( $this->defaultId ) );
    		
    		return $newNode;
    	}
    	
    	
		/* ----------------------------------------------------------------
		 * Ƥǥȥܤ򹹿롣
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
    	function update( $xpathEntry, $currentEntry )
    	{
    		// ȥXML
            $xmlEntryDataList = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
            $xmlEntryData = $xmlEntryDataList->nodeset[0];

		    // "name"°бPOST¸ߤСȥȿǤ롣
		    if ( isset( $_POST[ $this->dataName ] ) )
		    {
	            $datavalue = $_POST[ $this->dataName ];
				
				// ϰϥå¸ߤID
				if ( ! in_array( $datavalue, array_keys($this->menuitems) ) )
				{
					$this->errorMessage = sprintf( "%s ¸ߤʤ褬ꤵޤ", $this->dataCaption );
					return false;
				}
				
                // ޤƥȥΡɤʺʤȡset_contentǤϥƥȥΡɤˡ
                $xmlEntryData = $xmlEntryDataList->nodeset[0];
                EntryUtil::deleteTextNode( $xmlEntryData );
        		
    	        // ƥȥΡɤ˿ͤset롣
	    	    $xmlEntryData->set_content( fileconv( $datavalue ) );
    	    	//print( $dataname . " = " . htmlconv( $datavalue ) . "<br>\n" );
    	    }
    	    
    	    return true;
    	
    	}
    	
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItem( $xpathEntry, $currentEntry )
    	{
            $xmlEntryDataArray = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
    		$value = $xmlEntryDataArray->nodeset[0]->get_content();
    		
    		$strFormHTML = '<select name="' . $this->dataName . '">' . "\n";
			
			foreach ( $this->menuitems as $itemKey => $itemCaption )
    		{
				if ( $itemKey == $value )
				{
					$selected = 'selected';
				}
				else
				{
					$selected = '';
				}
				
				$strFormHTML .= '    <option value="' . $itemKey . '" ' . $selected . ' >' . htmlconv($itemCaption) . '</option>' . "\n";
    		}
			
            $strFormHTML .= '</select>' . "\n";
			
    		return $strFormHTML;
    	}
		
		/* ----------------------------------------------------------------
		 * եܤ褹HTML֤
		 * $xpathEntry : ȥXPath֥ȡ
		 * $currentEntry : ߤΥȥ֤ɽXPathʸ
		 */
		function renderFormItemXML( $xpathEntry, $currentEntry, &$xmlOutputEntryData )
    	{
            $xmlEntryDataArray = $xpathEntry->xpath_eval( $currentEntry . '/' . $this->dataName );
    		$value = $xmlEntryDataArray->nodeset[0]->get_content();
    		
			// ꥯȤͤСͤɽʥ顼ͤݾڤ褦ˤ
			if ( isset( $_POST[ $this->dataName ] ) )
			{
				$value = $_POST[ $this->dataName ];
			}
			
			$xmlDocOutput = $xmlOutputEntryData->owner_document();
			
			foreach ( $this->menuitems as $itemKey => $itemCaption )
    		{
				$xmlOutputOption = $xmlDocOutput->create_element('option');
				
				if ( $itemKey == $value )
				{
					$xmlOutputOption->set_attribute('selected', 'selected');
				}
				
				$xmlOutputOption->set_attribute('value', fileconv( $itemKey ) );
				$xmlOutputOption->set_content( fileconv( $itemCaption ) );
				
				$xmlOutputEntryData->append_child( $xmlOutputOption );
    		}
			
    	}		
    	
    }

?>